
;Point to the current frame
!FramePointer = ram1

;Point to the current frame on the animation
!AnFramePointer = ram2

;Point to the current animation
!AnPointer = ram3

;Time for the next frame change
!AnimationTimer = ram4	

!invisible = ram5
!tilesRelativePosition = ram6

!extraBit = $7FAB10,x

globalFlipper

localFlipper

LDA #$02
STA !invisible

STZ !FramePointer
STZ !AnPointer
STZ !AnFramePointer
LDA #$04
STA !AnimationTimer

RTL

PRINT "MAIN ",pc

PHB
PHK
PLB
JSR SpriteCode
PLB
RTL

;===================================
;Sprite Function
;===================================

Return:
	RTS

SpriteCode:
	LDA !invisible
	BNE .ret
	
+
	JSR Graphics ;graphic routine

	LDA $14C8,x			;\
	CMP #$08			; | If sprite dead,
	BNE .ret			;/ Return.
	
	JSL suboff

	LDA $9D				;\
	BNE .ret			;/ If locked, return.
	
	inter123
	JSR GraphicManager ;manage the frames of the sprite and decide what frame show

.ret
	JSR DynamicRoutine ;get a dynamic slot to make the dma routine using dynamic z
	RTS
	
;===================================
;Graphic Manager
;===================================	
GraphicManager:

	LDA !extraBit
	AND #$04
	LSR
	LSR
	STA $05 ;put the extra bit on $05
	
	LDA !DTimer ;timer
	AND #$01
	CMP $05 ;check if the extra bit is equal to the Dtimer last bit
	BNE .ret
	
	;if !AnimationTimer is Zero go to the next frame
	LDA !AnimationTimer
	BEQ ChangeFrame
.ret
	RTS

ChangeFrame:

	;Load the animation pointer X2
	LDA !AnPointer
	
	REP #$30
	AND #$00FF
	TAY
	
	
	LDA !AnFramePointer
	CLC
	ADC EndPositionAnim,y
	TAY
	SEP #$20
	
	LDA AnimationsFrames,y
	STA !FramePointer
	
	LDA AnimationsNFr,y
	STA !AnFramePointer
	
	LDA AnimationsTFr,y
	STA !AnimationTimer
	
	flLine
	
	SEP #$10
	
	RTS	
	